package org.jeecg.modules.fbsAbnormalWorkingHours.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursType;
import org.jeecg.modules.fbsAbnormalWorkingHours.service.IFbsAbnormalWorkingHoursTypeService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 异常类别
 * @author： jeecg-boot
 * @date：   2020-10-14
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsAbnormalWorkingHours/fbsAbnormalWorkingHoursType")
@Slf4j
public class FbsAbnormalWorkingHoursTypeController {
	@Autowired
	private IFbsAbnormalWorkingHoursTypeService fbsAbnormalWorkingHoursTypeService;
	
	/**
	  * 分页列表查询
	 * @param fbsAbnormalWorkingHoursType
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsAbnormalWorkingHoursType>> queryPageList(FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsAbnormalWorkingHoursType>> result = new Result<IPage<FbsAbnormalWorkingHoursType>>();
		QueryWrapper<FbsAbnormalWorkingHoursType> queryWrapper = QueryGenerator.initQueryWrapper(fbsAbnormalWorkingHoursType, req.getParameterMap());
		queryWrapper.lambda().eq(FbsAbnormalWorkingHoursType::getDelFlag,"0");
		queryWrapper.lambda().orderByAsc(FbsAbnormalWorkingHoursType::getSort);
		Page<FbsAbnormalWorkingHoursType> page = new Page<FbsAbnormalWorkingHoursType>(pageNo, pageSize);
		IPage<FbsAbnormalWorkingHoursType> pageList = fbsAbnormalWorkingHoursTypeService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsAbnormalWorkingHoursType
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsAbnormalWorkingHoursType> add(@RequestBody FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType) {
		Result<FbsAbnormalWorkingHoursType> result = new Result<FbsAbnormalWorkingHoursType>();
		try {
			fbsAbnormalWorkingHoursTypeService.save(fbsAbnormalWorkingHoursType);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsAbnormalWorkingHoursType
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsAbnormalWorkingHoursType> edit(@RequestBody FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType) {
		Result<FbsAbnormalWorkingHoursType> result = new Result<FbsAbnormalWorkingHoursType>();
		FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursTypeEntity = fbsAbnormalWorkingHoursTypeService.getById(fbsAbnormalWorkingHoursType.getId());
		if(fbsAbnormalWorkingHoursTypeEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsAbnormalWorkingHoursTypeService.updateById(fbsAbnormalWorkingHoursType);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsAbnormalWorkingHoursType> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsAbnormalWorkingHoursType> result = new Result<FbsAbnormalWorkingHoursType>();
		FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType = fbsAbnormalWorkingHoursTypeService.getById(id);
		if(fbsAbnormalWorkingHoursType==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsAbnormalWorkingHoursTypeService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsAbnormalWorkingHoursType> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsAbnormalWorkingHoursType> result = new Result<FbsAbnormalWorkingHoursType>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsAbnormalWorkingHoursTypeService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsAbnormalWorkingHoursType> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsAbnormalWorkingHoursType> result = new Result<FbsAbnormalWorkingHoursType>();
		FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType = fbsAbnormalWorkingHoursTypeService.getById(id);
		if(fbsAbnormalWorkingHoursType==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsAbnormalWorkingHoursType);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsAbnormalWorkingHoursType> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType = JSON.parseObject(deString, FbsAbnormalWorkingHoursType.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsAbnormalWorkingHoursType, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsAbnormalWorkingHoursType> pageList = fbsAbnormalWorkingHoursTypeService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "异常类别列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsAbnormalWorkingHoursType.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("异常类别列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsAbnormalWorkingHoursType> listFbsAbnormalWorkingHoursTypes = ExcelImportUtil.importExcel(file.getInputStream(), FbsAbnormalWorkingHoursType.class, params);
              for (FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursTypeExcel : listFbsAbnormalWorkingHoursTypes) {
                  fbsAbnormalWorkingHoursTypeService.save(fbsAbnormalWorkingHoursTypeExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsAbnormalWorkingHoursTypes.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
